focus -force .

canvas .c -width 800 -height 480 -bg white
pack .c
frame .f 
pack .f
button .f.cancel -text Ende -command {exit}
pack .f.cancel -padx 5 -pady 5 -side left

set Suche "Strae" ;#alternativ Stadt usw.

#Listenstruktur: Beschriftung = Tag, danach Tastenbreite in Pixel
set TLine(0) {Zielname 340}
set TLine(1) {A 60 B 60 C 60 D 60 E 60 F 60 G 60 H 60 I 60 J 60}
set TLine(2) {K 60 L 60 M 60 N 60 O 60 P 60 Q 60 R 60 S 60}
set TLine(3) {T 60 U 60 V 60 W 60 X 60 Y 60 Z 60  60 - 60 Lschen 120}
set TLine(4) {Mehr 90 0-9 60  60 Space 270  60  60 Liste 90}
set xdist(0) 240; set xdist(1) 30; set xdist(2) 65; set xdist(3) 30; set xdist(4) 30

#Leertaste sollte leer sein, Leerzeichen als Tag schwierig
proc myprint {c} {return [expr {$c == "Space" || $c == "Zielname" ? " " : $c}]}

#eine Reihe Tasten setzen, L ist Liste der Tasten, xoffset Abstand 
#links fr erste Taste, yoffset Abstand von oben, Tasten sind 60x60 plus 10 Rand
proc setKeys {L xoffset yoffset} {
  set n [expr [llength $L] / 2]
  set x $xoffset
  for {set i 0} {$i < $n} {incr i} {
	set keywidth [lindex $L [expr $i*2 + 1]]
    .c create rectangle $x  $yoffset [expr $x + $keywidth] [expr $yoffset + 60] \
		-outline "" -fill darkblue -tag "[lindex $L [expr $i*2]]"
	.c create text [expr $x + $keywidth / 2] [expr $yoffset + 30] \
		-fill white -text [myprint [lindex $L [expr $i*2]]] -font "Arial 18 bold" \
		-tag "Text[lindex $L [expr $i*2]]"
	#unsichtbaren Rahmen drberlegen fr Bindings
	.c create rectangle $x  $yoffset [expr $x + $keywidth] [expr $yoffset + 60] \
		-outline "" -fill "" -tag "Sensor[lindex $L [expr $i*2]]"
	set x [expr $x + $keywidth + 10]
  }
}

.c create rectangle 0 0 800 60 -outline "" -fill lightgray
for {set i 0} {$i < 5} {incr i} {
  setKeys $TLine($i) $xdist($i) [expr $i*70 + 70]
}
.c create rectangle 0 420 800 480 -outline "" -fill lightgray
.c create text 20 30 -text "Adresse" -tag adresse -anchor w -fill black -font "Arial 18"
.c create text 150 110 -text "$Suche" -tag Ziel -anchor sw -fill black -font "Arial 18"
.c create text 620 110 -text "****" -tag zaehler -anchor sw -fill black -font "Arial 18"
.c create text 780 30 -text "NaviTcl" -tag adresse -anchor e -fill black -font "Arial 18"
.c create text 750 450 -text "" -tag adresse -fill black -font "Wingdings 18 bold"
.c create text 20 450 -text "--:--" -tag zeit -fill black -anchor w -font "Arial 18"

#Uhr unten links einmal pro Sekunde aktualisieren
proc setclock {} {
	.c itemconfigure zeit -text [clock format [clock seconds] -format %R]
	update
	after 1000 setclock
}
setclock



#angezeigter Name soll linksbndig stehen
.c coords "TextZielname" 270 110
.c itemconfigure "TextZielname" -text "${Suche}namen eingeben" -anchor sw

#berechne eine Buchstabenliste fr den Bereich der Suchliste, der von Start bis Ende 
#geht; alle Zeichen links von Position P sind gleich (gleiches Prfix bis P-1)
#erstes Zeichen in einem String hat Index 0, string index $S $j fr j >= end liefert ""
#lindex auf leerer Liste liefert leeren String
proc ComputeKeyList {Suchliste P Start Ende} {
	set RListe {}
	for {set i $Start} {$i <= $Ende} {incr i} {
		set c [string index [lindex $Suchliste $i] $P]
		set c [expr {$c == " " ? "Space" : $c}]
		if {[string compare [lindex $RListe end] $c] != 0} {
			lappend RListe $c
		}
	}
	return $RListe
}

#Suche in der Suchliste von Start bis Ende alle Eintrge, die an
#der Position P das Zeichen letter haben und liefere die neuen Start-
#und Endewerte zurck.
proc ShrinkList {Suchliste P Start Ende letter} {
	set s $Start
	if {$letter == "Space"} {set letter " "}
	while {[string compare [string index [lindex $Suchliste $s] $P] "$letter"] < 0} {
	incr s}
	set e $Ende
	while {[string compare [string index [lindex $Suchliste $e] $P] "$letter"] > 0} {
	incr e -1}
	#Start-/Endewert als Zweierliste zurckliefern.
	return [list $s $e]
}

#alle alten Tasten in OldKList auf inaktiv setzen, neue aktivieren
proc AdjustKeyboard {OldKList NewKList} {
	#alle auf lightblue und leerem bind-Kommando setzen.
	foreach tag $OldKList {
		.c itemconfigure $tag -fill lightblue
		.c bind "Sensor$tag" <ButtonPress> {}
	}
	foreach tag $NewKList {
		.c itemconfigure $tag -fill darkblue
		.c bind "Sensor$tag" <ButtonPress> "add2ziel $tag"
	}
}

proc add2ziel {key} {
	global ziel KeyListe TestListe lines von bis pos AllKeys
	set posalt $pos; incr pos
	switch -- $key {
	  Space {set ziel($pos) "$ziel($posalt) "}
	  Lschen {set pos [expr $posalt - 1]; set posalt [expr $posalt - 2]}
	  default {set ziel($pos) "$ziel($posalt)$key"}
	}
	.c itemconfigure "TextZielname" -text "$ziel($pos)_"
	#Liste der Namen verkleinern gem Eingabezeichen falls nicht Lschen
	#??? Lschen neu behandeln 
	if {$key != "Lschen"} {
		set AE [ShrinkList $lines $posalt $von($posalt) $bis($posalt) $key]
		set von($pos) [lindex $AE 0] 
		set bis($pos) [lindex $AE 1]
	}
	set  verblieben [expr $bis($pos) - $von($pos) + 1]
	.c itemconfigure zaehler -text $verblieben
	if {$verblieben > 1} {
		set KeyListe($pos) [ComputeKeyList $lines $pos $von($pos) $bis($pos)]
		if {$pos > 0} {
			AdjustKeyboard $AllKeys [lappend KeyListe($pos) "Lschen"]
		} else {AdjustKeyboard $AllKeys $KeyListe($pos)
		}
	} else {
		set myziel [lindex $lines $von($pos)]
		.c itemconfigure "TextZielname" -text $myziel
		AdjustKeyboard $AllKeys {"Lschen"}
	}
}

#Sortierte (!) Auswahlliste einlesen - hier Straenverzeichnis Kassel
set fl [open "sortedstrvz.txt"]
set data [read $fl];# liest alle Daten auf einmal
close $fl
#trennt grosse Zeichenkette in Liste per New Line
set lines [split $data \n]
#sofort auf Grossbuchstaben wandeln
set n [llength $lines]
for {set i 0} {$i < $n} {incr i} {
  set lines [lreplace $lines $i $i [string toupper [lindex $lines $i]]]
}

set pos 0 ;#Vergleichsposition im Zielnamen = bisherige Prfixlnge
set von($pos) 0; set bis($pos) [expr [llength $lines] - 1]
.c itemconfigure zaehler -text [expr $bis($pos) - $von($pos) + 1]

set ziel($pos) "" ;#ziel = Prfix
set ListeAlphabet {A B C D E F G H I J K L M N O P Q R S T U V W X Y Z   }
set KeyListe(0) [ComputeKeyList $lines $pos $von($pos) $bis($pos)]
#erste Tastatur = gefundene Anfangsbuchstaben ohne Space, Mehr, Lschen, 0-9
set AllKeys [concat $ListeAlphabet {"Mehr" "Space" "0-9" "Lschen" "-" ""}]
AdjustKeyboard $AllKeys $KeyListe($pos)
update


